#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(0);

    int n, m; cin >> n >> m;
    int c[m];
    for (int i = 0; i < m; i ++) cin >> c[i];
    int dp[m + 1][n + 1] = {};
    int prv[m + 1][n + 1];
    for (int i = 0; i <= m; i ++) for (int j = 0; j <= n; j ++) prv[i][j] = -1;
    dp[0][0] = true;
    int parity = 0;

    for (int j = 0; j < m; j ++) {
        (parity += c[j]) %= 2;

        vector<int> add[n + 1], del[n + 1];
        for (int x = 0; x <= n; x ++) {
            if (!dp[j][x]) continue;

            int minA = max(0, c[j] + x - n);
            int maxA = min(x, c[j]);

            int minY = x - maxA + (c[j] - maxA);
            int maxY = x - minA + (c[j] - minA);

            add[minY].push_back(x);
            del[maxY].push_back(x);
        }

        set<int> st;
        for (int y = 0; y <= n; y ++) {
            for (int val : add[y]) st.insert(val);

            if (y % 2 == parity && !st.empty()) {
                dp[j + 1][y] = true;
                prv[j + 1][y] = *st.begin();
            }

            for (int val : del[y]) st.erase(st.find(val));
        }
    }
    int res = -1;
    for (int x = n; x >= 0; x --) {
        if (dp[m][x]) {
            res = x;
            break;
        }
    }

    cout << res << '\n';
    vector<int> x = {res};
    for (int j = m; j >= 1; j --) {
        x.push_back(prv[j][x.back()]);
    }
    x.pop_back();
    reverse(x.begin(), x.end());

    int a[n][m] = {};
    int p[n] = {};
    int cnt = 0;
    for (int j = 0; j < m; j ++) {
        int nxt = x[j];
        int X = (nxt + c[j] - cnt) / 2;
        int Y = c[j] - X;
        cnt = nxt;
        for (int i = 0; i < n; i ++) {
            if (p[i] == 0 && X >= 1) {
                X --;
                p[i] ^= 1;
                a[i][j] = 1;
            }
            else if (p[i] == 1 && Y >= 1) {
                Y --;
                p[i] ^= 1;
                a[i][j] = 1;
            }
        }
    }
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) cout << a[i][j] << ' ';
        cout << '\n';
    }
    return 0;
}
