#pragma GCC optimize("Ofast", "unroll-loops")

#include <bits/stdc++.h>

#define all(a) a.begin(),a.end()
#define len(a) (int)(a.size())
#define mp make_pair
#define pb push_back
#define fir first
#define sec second
#define fi first
#define se second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<typename T>
bool umin(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
bool umax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

#ifdef KIVI
#define DEBUG for (bool _FLAG = true; _FLAG; _FLAG = false)
#define LOG(...) print(#__VA_ARGS__" ::", __VA_ARGS__) << endl
template <class ...Ts> auto &print(Ts ...ts) { return ((cerr << ts << " "), ...); }
#else
#define DEBUG while (false)
#define LOG(...)
#endif

const int max_n = 4e5 + 11, inf = 1000111222;

struct query {
    int type, l, r;

    bool operator < (const query &x) const {
        return r < x.r;
    }
};

int a[max_n], b[max_n * 2], sp[max_n * 2], ans[max_n], used[max_n];

query Q[max_n];


const int C = 1500;

const int block_size = 547;


int c[max_n], n;

int block[max_n / block_size + 1], id[max_n], last[max_n * 2], save[C], val[C];

bitset<max_n * 2> rem;
bitset<C * 2> cur_rem;

query qq[C], upd[C], upd_rem[C];

inline void clear() {
    for (int i = 0; i < n; i++) {
        c[i] = 0;
    }
    for (int i = 0; i <= id[n - 1]; i++) {
        block[i] = 0;
    }
}

inline void add (int pos, int x) {
    c[pos] += x;
    block[id[pos]] += x;
}

inline int get_suff (int pos, int r) {
    int res = 0;
    int R = min(n, block_size * (id[pos] + 1)), now = id[pos];
    for (; pos < R; pos++) {
        res += c[pos];
    }
    r = id[r];
    for (++now; now <= r; now++) {
        res += block[now];
    }
    return res;
}

int sp_val[C * 2], save_pos[C], real_pos[C], last2[C * 2], alt[C * 2], to[max_n * 2];


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);


    int q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = a[i];
        id[i] = i / block_size;
    }
    int num = n;
    for (int i = 0; i < q; i++) {
        cin >> Q[i].type >> Q[i].l;
        if (Q[i].type == 1) {
            b[num++] = Q[i].l;
        }
        else if (Q[i].type == 2) {
            cin >> Q[i].r;
            --Q[i].l;
            --Q[i].r;
        }
        else if (Q[i].type == 3) {
            cin >> Q[i].r;
            --Q[i].l;
            b[num++] = Q[i].r;
        }
        else {
            assert(false);
        }
    }
    sort(b, b + num);
    int m = unique(b, b + num) - b;
    auto cmp = [&] (int x) {
        return int(lower_bound(b, b + m, x) - b);
    };
    for (int i = 0; i < n; i++) {
        a[i] = cmp(a[i]);
    }
    for (int i = 0; i < m; i++) {
        rem[i] = 1;
    }
    for (int i = 0; i < q; i++) {
        if (Q[i].type == 1) {
            Q[i].l = cmp(Q[i].l);
        }
        else if (Q[i].type == 3) {
            Q[i].r = cmp(Q[i].r);
        }
    }
    int timer = 0;
    for (int i = 0; i < q; i += C) {
        int r = min(q, i + C), cnt = 0, upd_cnt = 0, sp_cnt = 0, change_rem = 0;
        ++timer;
        for (int j = i; j < r; j++) {
            if (Q[j].type == 1) {
                sp[Q[j].l] = timer;
                upd_rem[change_rem] = query{j, Q[j].l, -1};
                ++change_rem;
                sp_val[sp_cnt] = Q[j].l;
                ++sp_cnt;
            }
            else if (Q[j].type == 3) {
                if (used[Q[j].l] != timer) {
                    sp_val[sp_cnt] = a[Q[j].l];
                    sp[a[Q[j].l]] = timer;
                    ++sp_cnt;
                }
                used[Q[j].l] = timer;
                sp[Q[j].r] = timer;
                upd[upd_cnt] = query{j, Q[j].l, Q[j].r};
                save_pos[upd_cnt] = Q[j].l;
                ++upd_cnt;

                sp_val[sp_cnt] = Q[j].r;
                ++sp_cnt;
            }
            else {
                qq[cnt] = Q[j];
                qq[cnt].type = j;
                ++cnt;
            }
        }


        sort(sp_val, sp_val + sp_cnt);
        sp_cnt = unique(sp_val, sp_val + sp_cnt) - sp_val;
        for (int j = 0; j < sp_cnt; j++) {
            alt[j] = -1;
            last2[j] = -1;
            cur_rem[j] = rem[sp_val[j]];
            to[sp_val[j]] = j;
        }

        sort(save_pos, save_pos + upd_cnt);
        int diff_pos = unique(save_pos, save_pos + upd_cnt) - save_pos;


        for (int j = 0; j < upd_cnt; j++) {
            int new_pos = lower_bound(save_pos, save_pos + diff_pos, upd[j].l) - save_pos;
            val[new_pos] = save[new_pos] = to[a[upd[j].l]];
            real_pos[j] = upd[j].l;
            int new_val = to[upd[j].r];

            upd[j].r = new_val;
            upd[j].l = new_pos;
        }


        for (int j = 0; j < change_rem; j++) {
            upd_rem[j].l = to[upd_rem[j].l];
        }



        sort(qq, qq + cnt);
        clear();
        for (int j = 0; j < m; j++) {
            last[j] = -1;
        }
        for (int j = 0, p = 0; j < n; j++) {
            if (sp[a[j]] != timer) {
                if (rem[a[j]]) {
                    int prv = last[a[j]];
                    if (prv != -1) {
                        add(prv, -1);
                    }
                    add(j, 1);
                }
                last[a[j]] = j;
            }
            else {
                if (used[j] != timer) {
                    last2[to[a[j]]] = j;
                }
            }
            while (p < cnt && qq[p].r == j) {
                for (int k = 0; k < upd_cnt && upd[k].type <= qq[p].type; k++) {
                    if (real_pos[k] <= j) {
                        val[upd[k].l] = upd[k].r;
                    }
                }
                for (int k = 0; k < upd_cnt; k++) {
                    if (real_pos[k] <= j) {
                        umax(alt[val[upd[k].l]], real_pos[k]);
                    }
                }

                for (int k = 0; k < change_rem && upd_rem[k].type <= qq[p].type; k++) {
                    cur_rem[upd_rem[k].l] = !cur_rem[upd_rem[k].l];
                }

                for (int k = 0; k < sp_cnt; k++) {
                    if (cur_rem[k] && max(last2[k], alt[k]) >= qq[p].l) {
                        ++ans[qq[p].type];
                    }
                }

                for (int k = 0; k < change_rem && upd_rem[k].type <= qq[p].type; k++) {
                    cur_rem[upd_rem[k].l] = !cur_rem[upd_rem[k].l];
                }


                for (int k = 0; k < upd_cnt; k++) {
                    if (real_pos[k] <= j) {
                        alt[val[upd[k].l]] = -1;
                        val[upd[k].l] = save[upd[k].l];
                    }
                }

                ans[qq[p].type] += get_suff(qq[p].l, j);
                ++p;
            }
        }

        for (int j = i; j < r; j++) {
            if (Q[j].type == 1) {
                rem[Q[j].l] = !rem[Q[j].l];
            }
            else if (Q[j].type == 3) {
                a[Q[j].l] = Q[j].r;
            }
        }

    }
    for (int i = 0; i < q; i++) {
        if (Q[i].type == 2) {
            cout << ans[i] << '\n';
        }
    }
}